package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.text.TextField;
	
	/**
	 * ...
	 * @author umhr
	 */
	[SWF(width = 400, height = 200, backgroundColor = 0xFFDDDD, frameRate = 30)]
	public class Main extends Sprite 
	{
		private var _textField:TextField = new TextField();
		private var _nameField:TextField = new TextField();
		private var _messageField:TextField = new TextField();
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			addTextField();
			
			//　ボタン
			var btn:Sprite = new Sprite();
			btn.graphics.beginFill(0xFFFF9999);
			btn.graphics.drawRoundRect(0, 0, 75, 21, 8, 8);
			btn.graphics.endFill();
			btn.x = 325;
			btn.y = 174;
			btn.addEventListener(MouseEvent.CLICK, btn_click);
			addChild(btn);
			
			// 外部（JS,C#）から呼ばれるコールバック関数の登録
			try {
				ExternalInterface.addCallback ("asFunction", callbackFunction);
				_textField.text = "コールバック関数の登録ができました。\n";
			}catch (error:Error) {
				_textField.text = "コールバック関数の登録ができませんでした。\n";
			}
		}
		
		/**
		 * 外部（JS,C#）から呼ばれるコールバック関数
		 * @param	...args
		 */
		private function callbackFunction(...args):void
		{
			addText(args[0], args[1]);
		}
		
		/**
		 * 外部（JS,C#）の関数の呼び出し
		 * @param	e
		 */
		private function btn_click(e:MouseEvent):void 
		{
			try {
				var message:String = _messageField.text;
				if (message == "") {
					// 何もないと、外部側でエラーになる場合がある。
					message = " ";
				}
				
				// 外部（JS,C#）関数の呼び出し
				ExternalInterface.call("fromAS", _nameField.text, message);
				
				// テキストフィールドにも書き込み。
				addText(_nameField.text, _messageField.text);
				_messageField.text = "";
			}catch (error:Error) {
				_textField.appendText("外部（JS,C#）の関数の呼び出しができませんでした。\n");
			}
		}
		
		/**
		 * テキストフィールドを作ってaddします。
		 */
		private function addTextField():void {
			
			//　テキストフィールド
			_textField.border = true;
			_textField.width = 399;
			_textField.height = 170;
			addChild(_textField);
			
			//　名前
			_nameField.border = true;
			_nameField.width = 85;
			_nameField.height = 20;
			_nameField.y = _textField.height + _textField.y + 4;
			_nameField.type = "input";
			_nameField.text = "Flash Program";
			addChild(_nameField);
			
			//　メッセージ
			_messageField.border = true;
			_messageField.width = 230;
			_messageField.height = 20;
			_messageField.x = _nameField.width + _nameField.x + 4;
			_messageField.y = _nameField.y;
			_messageField.type = "input";
			_messageField.text = "Hello from Flash!";
			addChild(_messageField);
		}
		
		/**
		 * テキストフィールドに書き込みをします。
		 * @param	name
		 * @param	message
		 */
		private function addText(name:String, message:String):void {
			_textField.appendText(name + ":" + message + "\n");
		}
		
	}
	
}